searchNodes=[{"doc":"","ref":"D2lvalenceElixir.html","title":"D2lvalenceElixir","type":"module"},{"doc":"Provides auth assistance for Desire2Learn's Valence API client applications.","ref":"D2lvalenceElixir.Auth.html","title":"D2lvalenceElixir.Auth","type":"module"},{"doc":"Build a new application context. :param app_id: D2L-provided Application ID string. :param app_key: D2L-provided Application Key string, used for signing.","ref":"D2lvalenceElixir.Auth.html#fashion_app_context/1","title":"D2lvalenceElixir.Auth.fashion_app_context/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Auth.html#fashion_user_context/1","title":"D2lvalenceElixir.Auth.fashion_user_context/1","type":"function"},{"doc":"Generic base module for a Valence Learning Framework API client application.","ref":"D2lvalenceElixir.Auth.D2LAppContext.html","title":"D2lvalenceElixir.Auth.D2LAppContext","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Auth.D2LAppContext.html#create_anonymous_user_context/3","title":"D2lvalenceElixir.Auth.D2LAppContext.create_anonymous_user_context/3","type":"function"},{"doc":"Build a URL that the user's browser can employ to complete the user authentication process with the back-end LMS. :param host: Host/port string for the back-end LMS service (i.e. lms.someUni.edu:443 ). To this parameter, this function adds the appropriate API route and parameters for a user-authentication request. :param client_app_url: Client application URL that the back-end service should redirect the user back to after user-authentication. :param connect_type: Provide a type string value of mobile to signal to the back-end service that the user-context will connect from a mobile device. :param encrypt_request: If true (default), generate an URL using a secure scheme (HTTPS); otherwise, generate an URL for an unsecure scheme (HTTP). Examples iex&gt; D2lvalenceElixir.Auth.D2LAppContext . create_url_for_authentication ( % D2lvalenceElixir.Auth.D2LAppContext { app_id : &quot;J5fm9B0Rq934mBQV9fGLWP&quot; , app_key : &quot;rYBPwHlBy0wPxlP-QZPedr&quot; } , &quot;lms.someUni.edu:443&quot; , &quot;http://localhost:8080/token&quot; ) &quot;https://lms.someUni.edu:443/d2l/auth/api/token?x_a=J5fm9B0Rq934mBQV9fGLWP&amp;x_b=-4KVKL-uNYeXopvBXFdM0SHZgyiQCVWu0oDmF5JkL48&amp;x_target=http%3A%2F%2Flocalhost%3A8080%2Ftoken&quot;","ref":"D2lvalenceElixir.Auth.D2LAppContext.html#create_url_for_authentication/5","title":"D2lvalenceElixir.Auth.D2LAppContext.create_url_for_authentication/5","type":"function"},{"doc":"Build a new authentication LMS-user context for a Valence Learning Framework API client application. :param result_uri: Entire result URI , including quoted parameters , that the back - end service redirected the user to after user - authentication . :param host: Host / port string for the back - end service ( i . e . ` lms . someUni . edu : 443 ` ) . :param encrypt_requests: If true , use HTTPS for requests made through the resulting built user context ; if false ( the default ) , use HTTP . :param d2l_user_context_props_dict: If the client application already has access to the properties dictionary saved from a previous user context , it can provide it with this property . If this paramter is not ` None ` , this builder function ignores the ` result_uri ` parameter as not needed .","ref":"D2lvalenceElixir.Auth.D2LAppContext.html#create_user_context/2","title":"D2lvalenceElixir.Auth.D2LAppContext.create_user_context/2","type":"function"},{"doc":"Creates the struct with the context information","ref":"D2lvalenceElixir.Auth.D2LAppContext.html#new/2","title":"D2lvalenceElixir.Auth.D2LAppContext.new/2","type":"function"},{"doc":"Default signer module that app and user contexts can use to create appropiately signed tokens","ref":"D2lvalenceElixir.Auth.D2LSigner.html","title":"D2lvalenceElixir.Auth.D2LSigner","type":"module"},{"doc":"Verify that a given digest value was produced by a compatible D2LSigner given your provided base string and key. key_string and base_string must be utf-8 encoded Examples iex&gt; D2lvalenceElixir.Auth.D2LSigner . check_hash ( &quot;qauJsGg4cG2iTriPq1N1cfElwYDs3vIATlNwIbFqUM0&quot; , [ 104 , 111 , 108 , 97 , 195 , 177 ] , &quot;hola&quot; ) true iex&gt; D2lvalenceElixir.Auth.D2LSigner . check_hash ( &quot;hj6sobenlkIElwSJKch0LgaPYU-fP3vlScIoWz-pN6U&quot; , &quot;hola&quot; , &quot;hola&quot; ) true","ref":"D2lvalenceElixir.Auth.D2LSigner.html#check_hash/3","title":"D2lvalenceElixir.Auth.D2LSigner.check_hash/3","type":"function"},{"doc":"Get a digest value suitable for direct inclusion into an URL's query parameter as a token. Note that Valence API services expect signatures to be generated with the following constraints: Encoding keys, and base strings, are UTF-8 encoded HMAC digests are generated using a standard SHA-256 hash Digests are then &quot;URL-safe&quot; base64 encoded (where - and _ substitute for + and / ) The resulting string is then stripped of all = characters, and all leading and trailing whitespace characters key_string and base_string must be utf-8 encoded Examples iex&gt; D2lvalenceElixir.Auth.D2LSigner . get_hash ( [ 104 , 111 , 108 , 97 , 195 , 177 ] , &quot;hola&quot; ) qauJsGg4cG2iTriPq1N1cfElwYDs3vIATlNwIbFqUM0 iex&gt; D2lvalenceElixir.Auth.D2LSigner . get_hash ( &quot;hola&quot; , &quot;hola&quot; ) hj6sobenlkIElwSJKch0LgaPYU - fP3vlScIoWz - pN6U","ref":"D2lvalenceElixir.Auth.D2LSigner.html#get_hash/2","title":"D2lvalenceElixir.Auth.D2LSigner.get_hash/2","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Auth.D2LUserContext.html","title":"D2lvalenceElixir.Auth.D2LUserContext","type":"module"},{"doc":"Create a properly tokenized URL for a new request through this user context. :param api_route: API route to invoke on the back-end service (get all versions route by default). :param method: Method for the request (GET by default, POST, etc). :returns: URI string you can fashion into an HTTP request, containing the time-limited authentication token parameters needed for a Valence API call.","ref":"D2lvalenceElixir.Auth.D2LUserContext.html#create_authenticated_url/2","title":"D2lvalenceElixir.Auth.D2LUserContext.create_authenticated_url/2","type":"function"},{"doc":"Create a properly tokenized URL for a new request through this user context, starting from a full URL. :param url: Full URL to call on the back-end service; no default value. param method: Method for the request (GET by default, POST, etc). :returns: URL you can use for an HTTP request, containing the time-limited authentication token parameters needed for a Valence API call.","ref":"D2lvalenceElixir.Auth.D2LUserContext.html#decorate_url_with_authentication/3","title":"D2lvalenceElixir.Auth.D2LUserContext.decorate_url_with_authentication/3","type":"function"},{"doc":"Creates a Full User Context from the app context and the simple authentication information created by get_simple_authentication_keys/1","ref":"D2lvalenceElixir.Auth.D2LUserContext.html#get_full_user_context/2","title":"D2lvalenceElixir.Auth.D2LUserContext.get_full_user_context/2","type":"function"},{"doc":"Takes a full D2LUserContext and returns a map with only the basic information for authentication. This is usefull for Phoenix session storage. You don't send app_id and app_key to the user.","ref":"D2lvalenceElixir.Auth.D2LUserContext.html#get_simple_user_context/1","title":"D2lvalenceElixir.Auth.D2LUserContext.get_simple_user_context/1","type":"function"},{"doc":"Interpret the result made for an API call through this user context. :param result_code: The HTTP result code from the response; if a successful result (2xx), this method ignores the response. :param response: Response passed back by the back-end service. The precise form of this is implementation dependent. It could be a string, or a file object, or a Response object of some kind. :param logfile: Optional. A caller might want to provide a file stream for logging purposes; if present, this method should write logging messages to this file stream. :returns: One of the enumerated D2LAuthResult class variables.","ref":"D2lvalenceElixir.Auth.D2LUserContext.html#interpret_result/4","title":"D2lvalenceElixir.Auth.D2LUserContext.interpret_result/4","type":"function"},{"doc":"Constructs a new authenticated calling user context. Clients are not intended to invoke this constructor directly; rather they should use the D2LAppContext.create_user_context() factory method, or the fashion_user_context() factory function. :param hostName: Host/port string for the back-end service. :param user_id: User ID provided by the back-end service to the authenticated client application . :param user_key: User Key provided by the back-end service to the authenticated client application . :param encrypt_requests: If true, use HTTPS for requests made through this user context ; if false ( the default ) , use HTTP . :param server_skew: Time skew between the service's time and the client application &#39; s time , in milliseconds . :param signer: A signer instance that implements D2LSigner. :return error:: If you provide None for hostName, port, user_id, or user_key parameters .","ref":"D2lvalenceElixir.Auth.D2LUserContext.html#new/1","title":"D2lvalenceElixir.Auth.D2LUserContext.new/1","type":"function"},{"doc":"Adjust the known time skew between the local client using this user context, and the back-end service. :param newSkewMillis: New server time-skew value, in milliseconds.","ref":"D2lvalenceElixir.Auth.D2LUserContext.html#set_new_skew/2","title":"D2lvalenceElixir.Auth.D2LUserContext.set_new_skew/2","type":"function"},{"doc":"Simple User Context to use for security issues. You can store this struct in Phoenix session without sending the app_key and app_id to the user.","ref":"D2lvalenceElixir.Auth.D2LUserContextSimple.html","title":"D2lvalenceElixir.Auth.D2LUserContextSimple","type":"module"},{"doc":"Provides definitions and support for handling Valence data structures","ref":"D2lvalenceElixir.Data.html","title":"D2lvalenceElixir.Data","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.ClasslistUser.html","title":"D2lvalenceElixir.Data.ClasslistUser","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.ClasslistUser.html#new/1","title":"D2lvalenceElixir.Data.ClasslistUser.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.CreateUserData.html","title":"D2lvalenceElixir.Data.CreateUserData","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.CreateUserData.html#brightspace_format/1","title":"D2lvalenceElixir.Data.CreateUserData.brightspace_format/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.CreateUserData.html#new/1","title":"D2lvalenceElixir.Data.CreateUserData.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.DropboxFolder.html","title":"D2lvalenceElixir.Data.DropboxFolder","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.DropboxFolder.html#new/1","title":"D2lvalenceElixir.Data.DropboxFolder.new/1","type":"function"},{"doc":"Downloaded files are stored in a temporary directory. It's recommended to delete this file after the download and copy. During the requests, files are represented with a D2lvalenceElixir.Data.FileResponse struct that contains two fields: :path - the path to the downloaded file on the filesystem :filename - the original filename of the downloaded file","ref":"D2lvalenceElixir.Data.FileResponse.html","title":"D2lvalenceElixir.Data.FileResponse","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.FileResponse.html#new/1","title":"D2lvalenceElixir.Data.FileResponse.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.GradeObject.html","title":"D2lvalenceElixir.Data.GradeObject","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.GradeObject.html#new/1","title":"D2lvalenceElixir.Data.GradeObject.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.GradeObjectNumeric.html","title":"D2lvalenceElixir.Data.GradeObjectNumeric","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.GradeObjectNumeric.html#new/1","title":"D2lvalenceElixir.Data.GradeObjectNumeric.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.GradeObjectPassFail.html","title":"D2lvalenceElixir.Data.GradeObjectPassFail","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.GradeObjectPassFail.html#new/1","title":"D2lvalenceElixir.Data.GradeObjectPassFail.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.GradeObjectSelectBox.html","title":"D2lvalenceElixir.Data.GradeObjectSelectBox","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.GradeObjectSelectBox.html#new/1","title":"D2lvalenceElixir.Data.GradeObjectSelectBox.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.GradeObjectText.html","title":"D2lvalenceElixir.Data.GradeObjectText","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.GradeObjectText.html#new/1","title":"D2lvalenceElixir.Data.GradeObjectText.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.GradeValue.html","title":"D2lvalenceElixir.Data.GradeValue","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.GradeValue.html#new/1","title":"D2lvalenceElixir.Data.GradeValue.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.GradeValueComputable.html","title":"D2lvalenceElixir.Data.GradeValueComputable","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.GradeValueComputable.html#new/1","title":"D2lvalenceElixir.Data.GradeValueComputable.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.PagedResultSet.html","title":"D2lvalenceElixir.Data.PagedResultSet","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.PagedResultSet.html#new/1","title":"D2lvalenceElixir.Data.PagedResultSet.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.SingleSubmissionForDropbox.html","title":"D2lvalenceElixir.Data.SingleSubmissionForDropbox","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.SingleSubmissionForDropbox.html#new/1","title":"D2lvalenceElixir.Data.SingleSubmissionForDropbox.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.SubmissionFile.html","title":"D2lvalenceElixir.Data.SubmissionFile","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.SubmissionFile.html#new/1","title":"D2lvalenceElixir.Data.SubmissionFile.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.SubmissionsForDropbox.html","title":"D2lvalenceElixir.Data.SubmissionsForDropbox","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.SubmissionsForDropbox.html#new/1","title":"D2lvalenceElixir.Data.SubmissionsForDropbox.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.SupportedVersionRequest.html","title":"D2lvalenceElixir.Data.SupportedVersionRequest","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.SupportedVersionRequest.html#brightspace_format/1","title":"D2lvalenceElixir.Data.SupportedVersionRequest.brightspace_format/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.UpdateUserData.html","title":"D2lvalenceElixir.Data.UpdateUserData","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.UpdateUserData.html#brightspace_format/1","title":"D2lvalenceElixir.Data.UpdateUserData.brightspace_format/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.UpdateUserData.html#new/1","title":"D2lvalenceElixir.Data.UpdateUserData.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.UserData.html","title":"D2lvalenceElixir.Data.UserData","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.UserData.html#new/1","title":"D2lvalenceElixir.Data.UserData.new/1","type":"function"},{"doc":"","ref":"D2lvalenceElixir.Data.WhoAmIUser.html","title":"D2lvalenceElixir.Data.WhoAmIUser","type":"module"},{"doc":"","ref":"D2lvalenceElixir.Data.WhoAmIUser.html#new/1","title":"D2lvalenceElixir.Data.WhoAmIUser.new/1","type":"function"},{"doc":"Provides a suite of convenience functions for making D2L Valence calls.","ref":"D2lvalenceElixir.Utils.Service.html","title":"D2lvalenceElixir.Utils.Service","type":"module"},{"doc":"Check if the Version of products requested are supported by the D2L instance Returns {:error, cause} when an error is caused. {:ok, list(map())} If application/json serializer available returns a list of maps with the check of every product. Parameters supported_version_request_list must be a list of %D2lvalenceElixir.Data.SupportedVersionRequest{} Options serializers: Map of availaber serializers. application/json recommended. body: Options to pass to the body of the request.","ref":"D2lvalenceElixir.Utils.Service.html#check_versions/3","title":"D2lvalenceElixir.Utils.Service.check_versions/3","type":"function"},{"doc":"Creates the user with the information provided. Returns {:error, cause} when an error is caused. {:ok, %D2lvalenceElixir.Data.UserData{}} the result contains the information created. Options version: version of the component to verify. If not specified, will get the version of the component. serializers: Map of availaber serializers. application/json recommended. body: Options to pass to the body of the request.","ref":"D2lvalenceElixir.Utils.Service.html#create_user/3","title":"D2lvalenceElixir.Utils.Service.create_user/3","type":"function"},{"doc":"Deletes the user with the user_id. Returns {:error, cause} when an error is caused. {:ok, body_parsed} the body_parsed depends on the available serializers. Parameters supported_version_request_list must be a list of %D2lvalenceElixir.Data.SupportedVersionRequest{} Options serializers: Map of availaber serializers. application/json recommended. body: Options to pass to the body of the request.","ref":"D2lvalenceElixir.Utils.Service.html#delete_user/3","title":"D2lvalenceElixir.Utils.Service.delete_user/3","type":"function"},{"doc":"Gets all the folders of the orgunit. Returns {:error, cause} when an error is caused. {:ok, list(%D2lvalenceElixir.Data.DropboxFolder{})} The result contains a list with all the folders for the orgunit. Options version: version of the component to verify. If not specified, will get the version of the component. serializers: Map of availaber serializers. application/json recommended. body: Options to pass to the body of the request.","ref":"D2lvalenceElixir.Utils.Service.html#get_all_dropbox_folders_for_orgunit/3","title":"D2lvalenceElixir.Utils.Service.get_all_dropbox_folders_for_orgunit/3","type":"function"},{"doc":"Get all the grade objects for the organization unit id. Returns {:error, cause} when an error is caused. {:ok, list(%D2lvalenceElixir.Data.GradeObjectNumeric{} | %D2lvalenceElixir.Data.GradeObjectPassFail{} | %D2lvalenceElixir.Data.GradeObjectText{} | %D2lvalenceElixir.Data.GradeObject{})} The result contains the information of the grade objects. Options version: version of the component to verify. If not specified, will get the version of the component. serializers: Map of availaber serializers. application/json recommended. body: Options to pass to the body of the request.","ref":"D2lvalenceElixir.Utils.Service.html#get_all_grade_objects_for_org/3","title":"D2lvalenceElixir.Utils.Service.get_all_grade_objects_for_org/3","type":"function"},{"doc":"Get all the grades from the user. Returns {:error, cause} when an error is caused. {:ok, list(%D2lvalenceElixir.Data.GradeValueComputable{}| %D2lvalenceElixir.Data.GradeValue{})} The result contains the information of the grade objects. Options version: version of the component to verify. If not specified, will get the version of the component. serializers: Map of availaber serializers. application/json recommended. body: Options to pass to the body of the request.","ref":"D2lvalenceElixir.Utils.Service.html#get_all_grade_values_for_user_in_org/4","title":"D2lvalenceElixir.Utils.Service.get_all_grade_values_for_user_in_org/4","type":"function"},{"doc":"Gets the versions of all components. Returns {:error, cause} when an error is caused. {:ok, list(map())} If application/json serializer available returns a list of maps with the products available and its versions: [%{&quot;LatestVersion&quot; =&gt; &quot;1.1&quot;, &quot;ProductCode&quot; =&gt; &quot;bas&quot;, &quot;SupportedVersions&quot; =&gt; [&quot;1.0&quot;, &quot;1.1&quot;]}] Options serializers: Map of availaber serializers. application/json recommended. body: Options to pass to the body of the request.","ref":"D2lvalenceElixir.Utils.Service.html#get_all_versions/2","title":"D2lvalenceElixir.Utils.Service.get_all_versions/2","type":"function"},{"doc":"Get the classlist of an org unit id Returns {:error, cause} when an error is caused. {:ok, list(%D2lvalenceElixir.Data.ClasslistUser{})} The result contains the information of the classlist. Options version: version of the component to verify. If not specified, will get the version of the component. serializers: Map of availaber serializers. application/json recommended. body: Options to pass to the body of the request.","ref":"D2lvalenceElixir.Utils.Service.html#get_classlist/3","title":"D2lvalenceElixir.Utils.Service.get_classlist/3","type":"function"},{"doc":"Gets all the files from an specific submission. Returns {:error, cause} when an error is caused. {:ok, list(%D2lvalenceElixir.Data.FileResponse{})} The result contains a list with all the files. The files are stored on a temporary path. Options version: version of the component to verify. If not specified, will get the version of the component. serializers: Map of availaber serializers. application/json recommended. body: Options to pass to the body of the request.","ref":"D2lvalenceElixir.Utils.Service.html#get_files_from_submission/5","title":"D2lvalenceElixir.Utils.Service.get_files_from_submission/5","type":"function"},{"doc":"Get all the submissions from the dropbox folder Returns {:error, cause} when an error is caused. {:ok, list(%{})} The result contains a list with all the submissions of the dropbox folder. Options version: version of the component to verify. If not specified, will get the version of the component. serializers: Map of availaber serializers. application/json recommended. body: Options to pass to the body of the request.","ref":"D2lvalenceElixir.Utils.Service.html#get_submissions_for_dropbox_folder/4","title":"D2lvalenceElixir.Utils.Service.get_submissions_for_dropbox_folder/4","type":"function"},{"doc":"Get the information of an user. Returns {:error, cause} when an error is caused. {:ok, %D2lvalenceElixir.Data.UserData{}} with the information requested Options serializers: Map of availaber serializers. application/json recommended. body: Options to pass to the body of the request.","ref":"D2lvalenceElixir.Utils.Service.html#get_user/3","title":"D2lvalenceElixir.Utils.Service.get_user/3","type":"function"},{"doc":"Get the users information. Returns {:error, cause} when an error is caused. {:ok, list(%D2lvalenceElixir.Data.UserData{})} when the org_defined_id is defined. {:ok, %D2lvalenceElixir.Data.UserData{}} when the user_name is defined and the org_defined_id is not defined. {:ok, %D2lvalenceElixir.Data.PagedResultSer{}} when only the bookmark is defined. Options serializers: Map of availaber serializers. application/json recommended. body: Options to pass to the body of the request. org_defined_id: Id of the organization. user_name: User name to obtain the information bookmark: Bookmark for the request","ref":"D2lvalenceElixir.Utils.Service.html#get_users/2","title":"D2lvalenceElixir.Utils.Service.get_users/2","type":"function"},{"doc":"Gets the version of a product component especified in product component. Returns {:error, cause} when an error is caused. {:ok, list} If application/json serializer available returns a list with the product versions available Options version: version of the component to verify. If not specified, will get the version of the component. serializers: Map of availaber serializers. application/json recommended. body: Options to pass to the body of the request.","ref":"D2lvalenceElixir.Utils.Service.html#get_versions_for_product_component/3","title":"D2lvalenceElixir.Utils.Service.get_versions_for_product_component/3","type":"function"},{"doc":"Calls the Whoami service of Brightspace. Returns {:error, cause} when an error is caused. {:ok, %D2lvalenceElixir.Data.WhoAmIUser{}} the result contains the information of the logged user. Options version: version of the component to verify. If not specified, will get the version of the component. serializers: Map of availaber serializers. application/json recommended. body: Options to pass to the body of the request.","ref":"D2lvalenceElixir.Utils.Service.html#get_whoami/2","title":"D2lvalenceElixir.Utils.Service.get_whoami/2","type":"function"},{"doc":"Creates the user with the information provided. Returns {:error, cause} when an error is caused. {:ok, %D2lvalenceElixir.Data.UserData{}} the result contains the information created. Options version: version of the component to verify. If not specified, will get the version of the component. serializers: Map of availaber serializers. application/json recommended. body: Options to pass to the body of the request.","ref":"D2lvalenceElixir.Utils.Service.html#update_user/4","title":"D2lvalenceElixir.Utils.Service.update_user/4","type":"function"},{"doc":"D2lvalenceElixir","ref":"readme.html","title":"D2lvalenceElixir","type":"extras"},{"doc":"Elixir implementation of d2lvalence to connecto to the Desire2Learn's Valence API. Based on Desire2Learn Client Library for Python Works with the Brightspace Api Rest Auth: The D2lvalenceElixir.Auth module provides assistance for the authentication needed to invoke Valence APIs. You use the module's functiones to create a %D2lvalenceElixir.Auth.D2LUserContext{} struct that you can then employ as an authentication helper. Service: The D2lvalenceElixir.Utils.Service module provides many functions to call the Brightspace API Rest according to their documentation.","ref":"readme.html#desire2learn-client-library-for-elixir","title":"D2lvalenceElixir - Desire2Learn Client Library for Elixir","type":"extras"},{"doc":"The package can be installed by adding d2lvalence_elixir to your list of dependencies in mix.exs : def deps do [ { :d2lvalence_elixir , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"D2lvalenceElixir - Installation","type":"extras"},{"doc":"HexDocs","ref":"readme.html#documentation","title":"D2lvalenceElixir - Documentation","type":"extras"},{"doc":"Authentication defmodule D2lvalenceElixir.Examples.SimpleAuthentication do alias D2lvalenceElixir.Auth.D2LAppContext alias D2lvalenceElixir.Auth.D2LUserContext alias D2lvalenceElixir.Auth.D2LUserContextSimple alias D2lvalenceElixir.Auth def get_url_to_authenticate ( app_id , app_key ) do # You recieve the app_id and the app_key and then use the host # of your Brightspace instance, the callback and True for SSL (https). # You send the result URL to the user so he can authenticate and then # you recieve the user_key and user_id in the callback url. Auth . fashion_app_context ( app_id : app_id , app_key : app_key ) |&gt; D2LAppContext . create_url_for_authentication ( &quot;bloqueneon.uniandes.edu.co&quot; , &quot;http://localhost:8080/token&quot; , true ) end def auth_token_handler ( result_url , app_id , app_key ) do # You take the full result url (including https://yourfancyapp:8080/callback) requested after login and then generates the # user_context than helps your application with all the authenticated requests to de Brightspace API { :ok , full_user_context = % D2LUserContext { } } = Auth . fashion_app_context ( app_id : app_id , app_key : app_key ) |&gt; D2LAppContext . create_user_context ( result_uri : result_url , host : &quot;bloqueneon.uniandes.edu.co&quot; , encrypt_requests : true ) # {full_user_context, simple_user_context}. I recommend to store the simple_user_context on the session # for security purposes (You must NOT share the app_id and app_key with the user) { full_user_context , full_user_context |&gt; D2LUserContext . get_simple_user_context ( ) } end def get_full_user_context ( % D2LUserContextSimple { } = simple_user_context , app_id , app_key ) do # If you only stores the D2LUserContextSimple, you have to generate the full_user_context to # make authenticated requests to the Brightspace API { :ok , % D2LUserContext { } = full_user_context } = Auth . fashion_app_context ( app_id : app_id , app_key : app_key ) |&gt; D2LUserContext . get_full_user_context ( simple_user_context ) full_user_context end end Simple calls defmodule D2lvalenceElixir.Examples.SimpleApiCalls do alias D2lvalenceElixir.Auth.D2LUserContext alias D2lvalenceElixir.Utils.Service alias D2lvalenceElixir.Data.WhoAmIUser def serializers do # To encode and decode the requests, you could need some serializers. # This function creates the map with the serializers you need. # You need an application/json at least. %{ } |&gt; Map . put ( &quot;application/json&quot; , Jason ) end def whoami_api_call ( % D2LUserContext { } = user_context ) do # With the user_context (full_user_context, not simple) you call the whoami # You have to send the serializers, at least an application/json to decode the result # I use this version because it works on my university # The WhoAmI call shows who is the authenticated with the user_context { :ok , user = % WhoAmIUser { } } = user_context |&gt; Service . get_whoami ( serializers : serializers ( ) , ver : &quot;1.23&quot; ) user end def get_all_versions_api_call ( % D2LUserContext { } = user_context ) do # With the user context, shows the information of all the products of the Brightspace instance { :ok , products_information } = user_context |&gt; Service . get_all_versions ( serializers : serializers ( ) , ver : &quot;1.23&quot; ) products_information end end","ref":"readme.html#use","title":"D2lvalenceElixir - Use","type":"extras"}]